searchNodes=[{"ref":"ChangesFollower.html","title":"ChangesFollower","type":"behaviour","doc":"A behaviour module for following live changes in a CouchDB. It is basically an extended GenServer and also inherits all of GenServer&#39;s callbacks and semantics. The main difference is the expected return value of init/1 and the new handle_change/2 callback. Resilence ChangesFollower tries to be as resilent as possible, automatically restarting closed connections and resuming on last known sequence numbers for certain kinds of errors. It also checks if the server actually sends heartbeats within the expected timeframe and resets the connection on failures. Callbacks There are 7 callbacks required to be implemented in a ChangesFollower. By adding use ChangesFollower to your module, Elixir will automatically define all 7 callbacks for you, leaving it up to you to implement the ones you want to customize. Implementation Details Internally, an ibrowse worker is spawned and monitored. Therefore a ChangesFollower is not part of a load balancing pool. Additional Note When setting the doc_ids option, any given filter option will be ignored."},{"ref":"ChangesFollower.html#call/3","title":"ChangesFollower.call/3","type":"function","doc":""},{"ref":"ChangesFollower.html#cast/2","title":"ChangesFollower.cast/2","type":"function","doc":""},{"ref":"ChangesFollower.html#code_change/3","title":"ChangesFollower.code_change/3","type":"function","doc":"Invoked to change the state of the GenServer when a different version of a module is loaded (hot code swapping) and the state&#39;s term structure should be changed. old_vsn is the previous version of the module (defined by the @vsn attribute) when upgrading. When downgrading the previous version is wrapped in a 2-tuple with first element :down. state is the current state of the GenServer and extra is any extra data required to change the state. Returning {:ok, new_state} changes the state to new_state and the code change is successful. Returning {:error, reason} fails the code change with reason reason and the state remains as the previous state. If code_change/3 raises the code change fails and the loop will continue with its previous state. Therefore this callback does not usually contain side effects. This callback is optional. Callback implementation for GenServer.code_change/3."},{"ref":"ChangesFollower.html#c:code_change/3","title":"ChangesFollower.code_change/3","type":"callback","doc":""},{"ref":"ChangesFollower.html#handle_call/3","title":"ChangesFollower.handle_call/3","type":"function","doc":"Invoked to handle synchronous call/3 messages. call/3 will block until a reply is received (unless the call times out or nodes are disconnected). request is the request message sent by a call/3, from is a 2-tuple containing the caller&#39;s PID and a term that uniquely identifies the call, and state is the current state of the GenServer. Returning {:reply, reply, new_state} sends the response reply to the caller and continues the loop with new state new_state. Returning {:reply, reply, new_state, timeout} is similar to {:reply, reply, new_state} except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:reply, reply, new_state, :hibernate} is similar to {:reply, reply, new_state} except the process is hibernated and will continue the loop once a message is in its message queue. If a message is already in the message queue this will be immediately. Hibernating a GenServer causes garbage collection and leaves a continuous heap that minimises the memory used by the process. Returning {:reply, reply, new_state, {:continue, continue}} is similar to {:reply, reply, new_state} except c:handle_continue/2 will be invoked immediately after with the value continue as first argument. Hibernating should not be used aggressively as too much time could be spent garbage collecting. Normally it should only be used when a message is not expected soon and minimising the memory of the process is shown to be beneficial. Returning {:noreply, new_state} does not send a response to the caller and continues the loop with new state new_state. The response must be sent with reply/2. There are three main use cases for not replying using the return value: To reply before returning from the callback because the response is known before calling a slow function. To reply after returning from the callback because the response is not yet available. To reply from another process, such as a task. When replying from another process the GenServer should exit if the other process exits without replying as the caller will be blocking awaiting a reply. Returning {:noreply, new_state, timeout | :hibernate | {:continue, continue}} is similar to {:noreply, new_state} except a timeout, hibernation or continue occurs as with a :reply tuple. Returning {:stop, reason, reply, new_state} stops the loop and terminate/2 is called with reason reason and state new_state. Then the reply is sent as the response to call and the process exits with reason reason. Returning {:stop, reason, new_state} is similar to {:stop, reason, reply, new_state} except a reply is not sent. This callback is optional. If one is not implemented, the server will fail if a call is performed against it. Callback implementation for GenServer.handle_call/3."},{"ref":"ChangesFollower.html#c:handle_call/3","title":"ChangesFollower.handle_call/3","type":"callback","doc":""},{"ref":"ChangesFollower.html#handle_cast/2","title":"ChangesFollower.handle_cast/2","type":"function","doc":"Invoked to handle asynchronous cast/2 messages. request is the request message sent by a cast/2 and state is the current state of the GenServer. Returning {:noreply, new_state} continues the loop with new state new_state. Returning {:noreply, new_state, timeout} is similar to {:noreply, new_state} except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:noreply, new_state, :hibernate} is similar to {:noreply, new_state} except the process is hibernated before continuing the loop. See handle_call/3 for more information. Returning {:noreply, new_state, {:continue, continue}} is similar to {:noreply, new_state} except c:handle_continue/2 will be invoked immediately after with the value continue as first argument. Returning {:stop, reason, new_state} stops the loop and terminate/2 is called with the reason reason and state new_state. The process exits with reason reason. This callback is optional. If one is not implemented, the server will fail if a cast is performed against it. Callback implementation for GenServer.handle_cast/2."},{"ref":"ChangesFollower.html#c:handle_cast/2","title":"ChangesFollower.handle_cast/2","type":"callback","doc":""},{"ref":"ChangesFollower.html#c:handle_change/2","title":"ChangesFollower.handle_change/2","type":"callback","doc":""},{"ref":"ChangesFollower.html#c:handle_error/2","title":"ChangesFollower.handle_error/2","type":"callback","doc":""},{"ref":"ChangesFollower.html#handle_info/2","title":"ChangesFollower.handle_info/2","type":"function","doc":"Invoked to handle all other messages. msg is the message and state is the current state of the GenServer. When a timeout occurs the message is :timeout. Return values are the same as handle_cast/2. This callback is optional. If one is not implemented, the received message will be logged. Callback implementation for GenServer.handle_info/2."},{"ref":"ChangesFollower.html#c:handle_info/2","title":"ChangesFollower.handle_info/2","type":"callback","doc":""},{"ref":"ChangesFollower.html#init/1","title":"ChangesFollower.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ChangesFollower.html#c:init/1","title":"ChangesFollower.init/1","type":"callback","doc":""},{"ref":"ChangesFollower.html#reply/2","title":"ChangesFollower.reply/2","type":"function","doc":""},{"ref":"ChangesFollower.html#retry_now/1","title":"ChangesFollower.retry_now/1","type":"function","doc":""},{"ref":"ChangesFollower.html#start/3","title":"ChangesFollower.start/3","type":"function","doc":""},{"ref":"ChangesFollower.html#start_link/3","title":"ChangesFollower.start_link/3","type":"function","doc":""},{"ref":"ChangesFollower.html#stop/3","title":"ChangesFollower.stop/3","type":"function","doc":""},{"ref":"ChangesFollower.html#terminate/2","title":"ChangesFollower.terminate/2","type":"function","doc":"Invoked when the server is about to exit. It should do any cleanup required. reason is exit reason and state is the current state of the GenServer. The return value is ignored. terminate/2 is called if a callback (except init/1) does one of the following: returns a :stop tuple raises calls Kernel.exit/1 returns an invalid value the GenServer traps exits (using Process.flag/2) and the parent process sends an exit signal If part of a supervision tree, a GenServer will receive an exit signal when the tree is shutting down. The exit signal is based on the shutdown strategy in the child&#39;s specification, where this value can be: :brutal_kill: the GenServer is killed and so terminate/2 is not called. a timeout value, where the supervisor will send the exit signal :shutdown and the GenServer will have the duration of the timeout to terminate. If after duration of this timeout the process is still alive, it will be killed immediately. For a more in-depth explanation, please read the &quot;Shutdown values (:shutdown)&quot; section in the Supervisor module. If the GenServer receives an exit signal (that is not :normal) from any process when it is not trapping exits it will exit abruptly with the same reason and so not call terminate/2. Note that a process does NOT trap exits by default and an exit signal is sent when a linked process exits or its node is disconnected. Therefore it is not guaranteed that terminate/2 is called when a GenServer exits. For such reasons, we usually recommend important clean-up rules to happen in separated processes either by use of monitoring or by links themselves. There is no cleanup needed when the GenServer controls a port (e.g. :gen_tcp.socket) or File.io_device/0, because these will be closed on receiving a GenServer&#39;s exit signal and do not need to be closed manually in terminate/2. If reason is neither :normal, :shutdown, nor {:shutdown, term} an error is logged. This callback is optional. Callback implementation for GenServer.terminate/2."},{"ref":"ChangesFollower.html#c:terminate/2","title":"ChangesFollower.terminate/2","type":"callback","doc":""},{"ref":"ChangesFollower.html#whereis/1","title":"ChangesFollower.whereis/1","type":"function","doc":""},{"ref":"ChangesFollower.html#t:changes_follower/0","title":"ChangesFollower.changes_follower/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:debug/0","title":"ChangesFollower.debug/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:from/0","title":"ChangesFollower.from/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:gen_option/0","title":"ChangesFollower.gen_option/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:name/0","title":"ChangesFollower.name/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:on_start/0","title":"ChangesFollower.on_start/0","type":"type","doc":""},{"ref":"ChangesFollower.html#t:option/0","title":"ChangesFollower.option/0","type":"type","doc":""},{"ref":"ICouch.html","title":"ICouch","type":"module","doc":"Main module of ICouch. Note: Multipart transmission is the default; you can disable it by setting adding option multipart: false. For saving, it is also possible to use a specific multipart boundary instead of a random one by setting the option to a string instead of boolean."},{"ref":"ICouch.html#all_dbs/1","title":"ICouch.all_dbs/1","type":"function","doc":"Returns a list of all the databases in the CouchDB instance."},{"ref":"ICouch.html#assert_db/3","title":"ICouch.assert_db/3","type":"function","doc":"Opens or creates a database and returns a handle on success. Returns an error if the database could not be created if it was missing. Implementation note: this tries to create the database first."},{"ref":"ICouch.html#assert_db!/3","title":"ICouch.assert_db!/3","type":"function","doc":"Same as assert_db/3 but returns the database directly on success or raises an error on failure."},{"ref":"ICouch.html#compact/1","title":"ICouch.compact/1","type":"function","doc":"Request compaction of the specified database."},{"ref":"ICouch.html#compact/2","title":"ICouch.compact/2","type":"function","doc":"Compacts the view indexes associated with the specified design document."},{"ref":"ICouch.html#copy_doc/4","title":"ICouch.copy_doc/4","type":"function","doc":"Copies an existing document to a new or existing document. Returns a map with the fields &quot;id&quot;, &quot;rev&quot; and &quot;ok&quot; on success."},{"ref":"ICouch.html#create_admin/3","title":"ICouch.create_admin/3","type":"function","doc":"Creates a new local admin user with the given password. This works for any CouchDB version by checking if the &quot;_membership&quot; route exists and then using set_config/4 or set_node_config/5 respectively."},{"ref":"ICouch.html#create_db/3","title":"ICouch.create_db/3","type":"function","doc":"Creates a database and returns a handle on success. Fails if the database already exists."},{"ref":"ICouch.html#create_db!/3","title":"ICouch.create_db!/3","type":"function","doc":"Same as create_db/3 but returns the database directly on success or raises an error on failure."},{"ref":"ICouch.html#db_exists?/2","title":"ICouch.db_exists?/2","type":"function","doc":"Tests if a database exists."},{"ref":"ICouch.html#db_info/1","title":"ICouch.db_info/1","type":"function","doc":"Gets information about the database."},{"ref":"ICouch.html#delete_attachment/4","title":"ICouch.delete_attachment/4","type":"function","doc":"Deletes a document attachment. A rev number is required if only the document ID is given instead of the document itself."},{"ref":"ICouch.html#delete_config/3","title":"ICouch.delete_config/3","type":"function","doc":"Deletes a configuration value. The returned JSON will be the value of the configuration parameter before it was deleted. CouchDB &lt; 2.0 only."},{"ref":"ICouch.html#delete_db/1","title":"ICouch.delete_db/1","type":"function","doc":"Deletes the database, and all the documents and attachments contained within it."},{"ref":"ICouch.html#delete_db/2","title":"ICouch.delete_db/2","type":"function","doc":"Deletes a database by name."},{"ref":"ICouch.html#delete_doc/3","title":"ICouch.delete_doc/3","type":"function","doc":"Deletes a document. This marks the specified document as deleted by adding a field _deleted with the value true. A rev number is required if only the document ID is given instead of the document itself."},{"ref":"ICouch.html#delete_node_config/4","title":"ICouch.delete_node_config/4","type":"function","doc":"Deletes a configuration value from a node. The returned JSON will be the value of the configuration parameter before it was deleted. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#doc_exists?/3","title":"ICouch.doc_exists?/3","type":"function","doc":"Tests if a document exists."},{"ref":"ICouch.html#dup_doc/3","title":"ICouch.dup_doc/3","type":"function","doc":"Duplicates an existing document by copying it to a new UUID obtained via get_uuid/1. Returns a map with the fields &quot;id&quot;, &quot;rev&quot; and &quot;ok&quot; on success."},{"ref":"ICouch.html#ensure_full_commit/1","title":"ICouch.ensure_full_commit/1","type":"function","doc":"Commits any recent changes to the specified database to disk."},{"ref":"ICouch.html#fetch_attachment/4","title":"ICouch.fetch_attachment/4","type":"function","doc":"Downloads a document attachment."},{"ref":"ICouch.html#fetch_attachment!/4","title":"ICouch.fetch_attachment!/4","type":"function","doc":"Same as fetch_attachment/4 but returns the data directly on success or raises an error on failure."},{"ref":"ICouch.html#get_config/1","title":"ICouch.get_config/1","type":"function","doc":"Returns the entire CouchDB server configuration. CouchDB &lt; 2.0 only."},{"ref":"ICouch.html#get_config/2","title":"ICouch.get_config/2","type":"function","doc":"Gets the configuration structure for a single section. CouchDB &lt; 2.0 only."},{"ref":"ICouch.html#get_config/3","title":"ICouch.get_config/3","type":"function","doc":"Gets a single configuration value from within a specific configuration section. CouchDB &lt; 2.0 only."},{"ref":"ICouch.html#get_doc_rev/2","title":"ICouch.get_doc_rev/2","type":"function","doc":"Retrieves the last revision of the document with the specified id."},{"ref":"ICouch.html#get_node_config/2","title":"ICouch.get_node_config/2","type":"function","doc":"Returns the entire CouchDB node configuration. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#get_node_config/3","title":"ICouch.get_node_config/3","type":"function","doc":"Gets the configuration structure for a single section of a node. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#get_node_config/4","title":"ICouch.get_node_config/4","type":"function","doc":"Gets a single configuration value from within a specific configuration section of a node. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#get_revs_limit/1","title":"ICouch.get_revs_limit/1","type":"function","doc":"Gets the current revision limit setting. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#get_security/1","title":"ICouch.get_security/1","type":"function","doc":"Returns the current security object from the specified database."},{"ref":"ICouch.html#get_uuid/1","title":"ICouch.get_uuid/1","type":"function","doc":"Requests one UUID from the CouchDB instance. Note that this is not strictly UUID compliant; it will in fact return a 32 character hexadecimal string."},{"ref":"ICouch.html#get_uuid!/1","title":"ICouch.get_uuid!/1","type":"function","doc":"Same as get_uuid/1 but returns the value directly on success or raises an error on failure."},{"ref":"ICouch.html#get_uuids/2","title":"ICouch.get_uuids/2","type":"function","doc":"Requests one or more UUIDs from the CouchDB instance. Note that this is not strictly UUID compliant; it will in fact return a list of 32 character hexadecimal strings."},{"ref":"ICouch.html#get_uuids!/2","title":"ICouch.get_uuids!/2","type":"function","doc":"Same as get_uuids/2 but returns the value directly on success or raises an error on failure."},{"ref":"ICouch.html#has_admin_party?/1","title":"ICouch.has_admin_party?/1","type":"function","doc":"Tests if the server is on an admin party. This is achieved by temporarily stripping credentials from the server struct and trying to call server_membership/1 (followed by a call to get_config(server, &quot;couchdb&quot;, &quot;database_dir&quot;) if the server does not have that route)."},{"ref":"ICouch.html#json_byte_size/1","title":"ICouch.json_byte_size/1","type":"function","doc":"Utility function which calculates the size of the corresponding JSON data of the given parameter. Since UTF-8 strings are to be used everywhere, this should be accurate."},{"ref":"ICouch.html#open_changes/2","title":"ICouch.open_changes/2","type":"function","doc":"Opens a changes feed in a database. This always succeeds and returns an unfetched ICouch.Changes.t struct. Note that when setting the doc_ids option, any given filter option will be ignored while fetching changes. See also: ChangesFollower"},{"ref":"ICouch.html#open_db/2","title":"ICouch.open_db/2","type":"function","doc":"Opens an existing database and returns a handle on success. Does check if the database exists."},{"ref":"ICouch.html#open_db!/2","title":"ICouch.open_db!/2","type":"function","doc":"Same as open_db/2 but returns the database directly on success or raises an error on failure."},{"ref":"ICouch.html#open_doc/3","title":"ICouch.open_doc/3","type":"function","doc":"Opens a document in a database."},{"ref":"ICouch.html#open_doc!/3","title":"ICouch.open_doc!/3","type":"function","doc":"Same as open_doc/3 but returns the document directly on success or raises an error on failure."},{"ref":"ICouch.html#open_docs/3","title":"ICouch.open_docs/3","type":"function","doc":"Opens several documents in a database. The parameter can be a list of strings (document IDs) or tuples of two strings (document ID + revision) or tuples of three strings (document ID + revision + attributes since) or maps (see CouchDB documentation) or any mix of those. CouchDB &gt;= 2.0 only. You can similar results using the &quot;_all_docs&quot; view on CouchDB &lt; 2.0."},{"ref":"ICouch.html#open_docs!/3","title":"ICouch.open_docs!/3","type":"function","doc":"Same as open_docs/3 but returns the documents directly on success or raises an error on failure."},{"ref":"ICouch.html#open_view/3","title":"ICouch.open_view/3","type":"function","doc":"Opens a view in a database. This will check if the design document exists and return a ICouch.View.t struct which can be iterated using Enum functions. The returned view is unfetched. The name should be in the form design_doc_name/view_name except for &quot;_all_docs&quot;, &quot;_design_docs&quot; and &quot;_local_docs&quot;. Note that the &quot;_all_docs&quot;, &quot;_design_docs&quot; and &quot;_local_docs&quot; view is not checked for existence; the latter two are only available on CouchDB &gt;= 2.0."},{"ref":"ICouch.html#open_view!/3","title":"ICouch.open_view!/3","type":"function","doc":"Same as open_view/3 but returns the view struct directly on success or raises an error on failure."},{"ref":"ICouch.html#put_attachment/5","title":"ICouch.put_attachment/5","type":"function","doc":"Uploads a document attachment. In order to stream the attachment body, a function of arity 0 or 1 can be provided that should return {:ok, data} or :eof. A rev number is required if only the document ID is given instead of the document itself."},{"ref":"ICouch.html#read_attachment_data_from_stream/2","title":"ICouch.read_attachment_data_from_stream/2","type":"function","doc":"Reads all attachment data from the referenced streaming source."},{"ref":"ICouch.html#read_doc_from_stream/2","title":"ICouch.read_doc_from_stream/2","type":"function","doc":"Builds a full document from the referenced streaming source."},{"ref":"ICouch.html#save_doc/3","title":"ICouch.save_doc/3","type":"function","doc":"Creates a new document or creates a new revision of an existing document. If the document does not have an &quot;_id&quot; property, the function will obtain a new UUID via get_uuid/1. Returns the saved document with updated revision on success. If a map is passed instead of a Document struct, it will be converted to a ICouch.Document.t first."},{"ref":"ICouch.html#save_doc!/3","title":"ICouch.save_doc!/3","type":"function","doc":"Same as save_doc/3 but returns the updated document directly on success or raises an error on failure."},{"ref":"ICouch.html#save_docs/3","title":"ICouch.save_docs/3","type":"function","doc":"Creates and updates multiple documents at the same time within a single request. It is possible to mix Document structs and plain maps."},{"ref":"ICouch.html#server_connection/0","title":"ICouch.server_connection/0","type":"function","doc":"Creates a server connection. Equivalent to server_connection(&quot;http://127.0.0.1:5984&quot;)"},{"ref":"ICouch.html#server_connection/2","title":"ICouch.server_connection/2","type":"function","doc":"Creates a server connection. Pass either an URI string or URI struct. Basic authorization is supported via URI &quot;http://user:pass@example.com:5984/&quot; or via options. Note that omitting the port number will result in port 80 (or 443) as per URI standards. The given URI acts as base URI for requests; any CouchDB API calls will be relative to it. That said, the last path element (usually) should be terminated with a / due to the way how relative URIs work. See (RFC 3986)[http://tools.ietf.org/html/rfc3986#section-5.2]. Also note that this does not actually establish a connection; use server_info/1 to test connectivity. The available options are mostly equivalent to ibrowse&#39;s, but use the string type where applicable. Not all options are supported. See the ICouch.Server module for a list."},{"ref":"ICouch.html#server_info/1","title":"ICouch.server_info/1","type":"function","doc":"Returns meta information about the server instance."},{"ref":"ICouch.html#server_membership/1","title":"ICouch.server_membership/1","type":"function","doc":"Returns the server&#39;s membership. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#set_config/4","title":"ICouch.set_config/4","type":"function","doc":"Updates a configuration value. The new value should be in the correct JSON-serializable format. In response CouchDB sends old value for target section key. CouchDB &lt; 2.0 only."},{"ref":"ICouch.html#set_node_config/5","title":"ICouch.set_node_config/5","type":"function","doc":"Updates a configuration value on a node. The new value should be in the correct JSON-serializable format. In response CouchDB sends old value for target section key. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#set_revs_limit/2","title":"ICouch.set_revs_limit/2","type":"function","doc":"Gets the current revision limit setting. CouchDB &gt;= 2.0 only."},{"ref":"ICouch.html#set_security/2","title":"ICouch.set_security/2","type":"function","doc":"Sets the security object for the given database."},{"ref":"ICouch.html#stream_attachment/5","title":"ICouch.stream_attachment/5","type":"function","doc":"Start streaming a document attachment to the given process. See ICouch.StreamChunk and ICouch.StreamEnd. The returned value will be the stream reference."},{"ref":"ICouch.html#stream_cancel/1","title":"ICouch.stream_cancel/1","type":"function","doc":"Cancels a stream operation."},{"ref":"ICouch.html#stream_doc/4","title":"ICouch.stream_doc/4","type":"function","doc":"Start streaming a document in a database to the given process. See ICouch.StreamChunk and ICouch.StreamEnd. The returned value will be the stream reference. If attachments are requested, they will be streamed separately, even if the server does not support multipart."},{"ref":"ICouch.html#view_cleanup/1","title":"ICouch.view_cleanup/1","type":"function","doc":"Removes view index files that are no longer required by CouchDB as a result of changed views within design documents."},{"ref":"ICouch.html#t:copy_delete_doc_option/0","title":"ICouch.copy_delete_doc_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:create_db_option/0","title":"ICouch.create_db_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:delete_attachment_option/0","title":"ICouch.delete_attachment_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:fetch_attachment_option/0","title":"ICouch.fetch_attachment_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:open_changes_option/0","title":"ICouch.open_changes_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:open_doc_option/0","title":"ICouch.open_doc_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:open_docs_option/0","title":"ICouch.open_docs_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:open_view_option/0","title":"ICouch.open_view_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:put_attachment_option/0","title":"ICouch.put_attachment_option/0","type":"type","doc":""},{"ref":"ICouch.html#t:ref/0","title":"ICouch.ref/0","type":"type","doc":""},{"ref":"ICouch.html#t:save_doc_option/0","title":"ICouch.save_doc_option/0","type":"type","doc":""},{"ref":"ICouch.Changes.html","title":"ICouch.Changes","type":"module","doc":"Module to handle changes feeds in CouchDB. Changes structs should not be created or manipulated directly, please use ICouch.open_changes/2. Similar to a view, a changes feed can be in a &quot;fetched&quot; state or in an &quot;unfetched&quot; state which can be tested with the fetched?/1 function and changed with the fetch/1, fetch!/1 and unfetch/1 function. In contrast to a view, the sequence number is updated on each fetch so a consecutive fetch will start off at the last sequence number. The changes struct implements the enumerable protocol for easy handling with Elixir&#39;s Enum module - however, this only works with fetched changes and will fail with an ArgumentError otherwise."},{"ref":"ICouch.Changes.html#db_endpoint/1","title":"ICouch.Changes.db_endpoint/1","type":"function","doc":"Internal function to build a db endpoint."},{"ref":"ICouch.Changes.html#delete_option/2","title":"ICouch.Changes.delete_option/2","type":"function","doc":"Deletes an option in changes. This will also set the changes feed back to the &quot;unfetched&quot; state. Returns changes unchanged if the option was not set (and it already was &quot;unfetched&quot;)."},{"ref":"ICouch.Changes.html#fetch/1","title":"ICouch.Changes.fetch/1","type":"function","doc":"Fetches all results of changes, turning it into a &quot;fetched changes feed&quot;. The last sequence number will be set and used as next &quot;since&quot; parameter."},{"ref":"ICouch.Changes.html#fetch!/1","title":"ICouch.Changes.fetch!/1","type":"function","doc":"Same as fetch/1 but returns the fetched changes feed directly on success or raises an error on failure."},{"ref":"ICouch.Changes.html#fetched?/1","title":"ICouch.Changes.fetched?/1","type":"function","doc":"Tests whether changes is in &quot;fetched&quot; state or not."},{"ref":"ICouch.Changes.html#get_option/2","title":"ICouch.Changes.get_option/2","type":"function","doc":"Returns the value of an option in changes or nil if it was not set. The last_seq value can be retrieved with the since option."},{"ref":"ICouch.Changes.html#put_option/3","title":"ICouch.Changes.put_option/3","type":"function","doc":"Adds or updates a single option in changes. This will also set the changes feed back to the &quot;unfetched&quot; state. To modify the last_seq value, set the since option. Note that when setting the doc_ids option, any given filter option will be ignored while fetching changes."},{"ref":"ICouch.Changes.html#set_options/2","title":"ICouch.Changes.set_options/2","type":"function","doc":"Replaces changes&#39;s options with the given ones. This set the changes feed back to the &quot;unfetched&quot; state, but leaves the last_seq value untouched unless since is given as option. Note that when setting the doc_ids option, any given filter option will be ignored while fetching changes."},{"ref":"ICouch.Changes.html#unfetch/1","title":"ICouch.Changes.unfetch/1","type":"function","doc":"Resets changes back to the &quot;unfetched&quot; state. This will also reset the last_seq to nil."},{"ref":"ICouch.Changes.html#t:changes_option_key/0","title":"ICouch.Changes.changes_option_key/0","type":"type","doc":""},{"ref":"ICouch.Changes.html#t:changes_option_value/0","title":"ICouch.Changes.changes_option_value/0","type":"type","doc":""},{"ref":"ICouch.Changes.html#t:t/0","title":"ICouch.Changes.t/0","type":"type","doc":""},{"ref":"ICouch.Collection.html","title":"ICouch.Collection","type":"module","doc":"Collection of documents useful for batch tasks. This module helps collecting documents together for batch uploading. It keeps track of the document byte sizes to allow a size cap and supports replacing a document already in the collection. Furthermore it is possible to associate meta data with documents (e.g. a sequence number). There are implementations for the Enumerable and Collectable protocol for your convenience. All functions with the _meta suffix return the document and meta data as 2-tuple, unless otherwise specified."},{"ref":"ICouch.Collection.html#byte_size/1","title":"ICouch.Collection.byte_size/1","type":"function","doc":"Returns the byte size of all documents in the collection as if they were encoded entirely in JSON (including attachments in Base64)."},{"ref":"ICouch.Collection.html#count/1","title":"ICouch.Collection.count/1","type":"function","doc":"Returns the number of documents in the collection."},{"ref":"ICouch.Collection.html#delete/2","title":"ICouch.Collection.delete/2","type":"function","doc":"Deletes a document in coll, referenced by its ID or itself. If the document does not exist, returns coll unchanged."},{"ref":"ICouch.Collection.html#doc_ids/1","title":"ICouch.Collection.doc_ids/1","type":"function","doc":"Returns all document IDs as list."},{"ref":"ICouch.Collection.html#doc_revs/1","title":"ICouch.Collection.doc_revs/1","type":"function","doc":"Returns a list of tuples pairing document IDs and their rev values."},{"ref":"ICouch.Collection.html#doc_revs_meta/1","title":"ICouch.Collection.doc_revs_meta/1","type":"function","doc":"Returns a list of tuples with document IDs, their rev values and metadata."},{"ref":"ICouch.Collection.html#empty?/1","title":"ICouch.Collection.empty?/1","type":"function","doc":"Returns whether the collection is empty."},{"ref":"ICouch.Collection.html#fetch/2","title":"ICouch.Collection.fetch/2","type":"function","doc":"Fetches the document of a specific doc_id in the given coll. If coll contains the document with the given doc_id, then {:ok, doc} is returned. If coll doesn&#39;t contain the document, :error is returned. Part of the Access behavior."},{"ref":"ICouch.Collection.html#fetch_meta/2","title":"ICouch.Collection.fetch_meta/2","type":"function","doc":"Fetches the document and its meta data for a specific doc_id in the given coll. If coll contains the document with the given doc_id, then {:ok, {doc, meta}} is returned. If coll doesn&#39;t contain the document, :error is returned."},{"ref":"ICouch.Collection.html#get/3","title":"ICouch.Collection.get/3","type":"function","doc":"Gets the document for a specific doc_id in coll. If coll contains the document with the given doc_id, then the document is returned. Otherwise, default is returned (which is nil unless specified otherwise). Part of the Access behavior."},{"ref":"ICouch.Collection.html#get_and_update/3","title":"ICouch.Collection.get_and_update/3","type":"function","doc":"Gets the document for a specific doc_id and updates it, all in one pass. fun is called with the current document under doc_id in coll (or nil if the document is not present in coll) and must return a two-element tuple: the &quot;get&quot; document (the retrieved document, which can be operated on before being returned) and the new document to be stored under doc_id in the resulting new collection. fun may also return :pop, which means the document shall be removed from coll and returned (making this function behave like Collection.pop(coll, doc_id). The returned value is a tuple with the &quot;get&quot; document returned by fun and a new collection with the updated document under doc_id. Not that it is possible to return a document plus meta data from fun. Part of the Access behavior."},{"ref":"ICouch.Collection.html#get_and_update_meta/3","title":"ICouch.Collection.get_and_update_meta/3","type":"function","doc":"Gets the document and its meta data for a specific doc_id and updates it, all in one pass. fun is called with the current document and meta data under doc_id in coll (or nil if the document is not present in coll) and must return a two-element tuple: the &quot;get&quot; meta data (the retrieved meta data, which can be operated on before being returned) and the new meta data to be stored under doc_id in the resulting new collection. fun may also return :pop, which means the document shall be removed from coll and its meta data returned (making this function behave like Collection.pop_meta(coll, doc_id). The returned value is a tuple with the &quot;get&quot; document and meta data returned by fun and a new collection with the updated document and meta data under doc_id."},{"ref":"ICouch.Collection.html#get_meta/3","title":"ICouch.Collection.get_meta/3","type":"function","doc":"Gets the document and its meta data for a specific doc_id in coll. If coll contains the document with the given doc_id, then the document and its meta data is returned. Otherwise, default is returned (which is nil unless specified otherwise)."},{"ref":"ICouch.Collection.html#member?/2","title":"ICouch.Collection.member?/2","type":"function","doc":"Checks if a document exists within the collection. If a string is given as parameter, checks if a document with that ID exists. If a 2-tuple of two strings is given, the first element is the document ID and the second element the revision to check. Otherwise a document or a 2-tuple of document and meta data can be given. Documents are tested using ICouch.Document.equal?/2 if they exist. Meta data is compared using ==."},{"ref":"ICouch.Collection.html#new/0","title":"ICouch.Collection.new/0","type":"function","doc":"Initialize a collection struct."},{"ref":"ICouch.Collection.html#pop/3","title":"ICouch.Collection.pop/3","type":"function","doc":"Returns and removes a document from coll, referenced by its ID or itself. If the document is present in coll, {doc, new_coll} is returned where new_coll is the result of removing the document from coll. If the document is not present in coll, {default, coll} is returned."},{"ref":"ICouch.Collection.html#pop_meta/3","title":"ICouch.Collection.pop_meta/3","type":"function","doc":"Returns and removes a document and its meta data from coll, referenced by its ID or itself. If the document is present in coll, {{doc, meta}, new_coll} is returned where new_coll is the result of removing the document from coll. If the document is not present in coll, {default, coll} is returned."},{"ref":"ICouch.Collection.html#put/2","title":"ICouch.Collection.put/2","type":"function","doc":"Puts a document into the collection, replacing an existing document if needed. Also accepts a 2-tuple of a document and meta data; meta data is set to nil if not given."},{"ref":"ICouch.Collection.html#put/3","title":"ICouch.Collection.put/3","type":"function","doc":"Puts a document with meta data into the collection, replacing an existing document and meta data if needed."},{"ref":"ICouch.Collection.html#set_meta/3","title":"ICouch.Collection.set_meta/3","type":"function","doc":"Replaces meta data of the document specified by doc_id in the collection. Warning: if the document does not exist, returns coll unchanged."},{"ref":"ICouch.Collection.html#to_list/1","title":"ICouch.Collection.to_list/1","type":"function","doc":"Returns all documents as list."},{"ref":"ICouch.Collection.html#to_list_meta/1","title":"ICouch.Collection.to_list_meta/1","type":"function","doc":"Returns all documents and meta data as list of tuples."},{"ref":"ICouch.Collection.html#t:doc_id/0","title":"ICouch.Collection.doc_id/0","type":"type","doc":""},{"ref":"ICouch.Collection.html#t:doc_rev/0","title":"ICouch.Collection.doc_rev/0","type":"type","doc":""},{"ref":"ICouch.Collection.html#t:meta/0","title":"ICouch.Collection.meta/0","type":"type","doc":""},{"ref":"ICouch.Collection.html#t:t/0","title":"ICouch.Collection.t/0","type":"type","doc":""},{"ref":"ICouch.DB.html","title":"ICouch.DB","type":"module","doc":"Holds information about CouchDB databases."},{"ref":"ICouch.DB.html#exists/1","title":"ICouch.DB.exists/1","type":"function","doc":"Internal function that checks if a database exists."},{"ref":"ICouch.DB.html#new/2","title":"ICouch.DB.new/2","type":"function","doc":"Initialize a DB struct."},{"ref":"ICouch.DB.html#send_raw_req/6","title":"ICouch.DB.send_raw_req/6","type":"function","doc":"Invokes an arbitrary CouchDB API call on a database which may or may not be implementation specific. See ICouch.Server.send_raw_req/6."},{"ref":"ICouch.DB.html#send_req/4","title":"ICouch.DB.send_req/4","type":"function","doc":"Invokes an arbitrary CouchDB API call on a database which may or may not be implementation specific. See ICouch.Server.send_req/4."},{"ref":"ICouch.DB.html#server_endpoint/2","title":"ICouch.DB.server_endpoint/2","type":"function","doc":"Internal function to build a server endpoint. Basically prepends the database name to the given URL path segment."},{"ref":"ICouch.DB.html#t:t/0","title":"ICouch.DB.t/0","type":"type","doc":""},{"ref":"ICouch.Document.html","title":"ICouch.Document","type":"module","doc":"Module which handles CouchDB documents. The struct&#39;s main use is to to conveniently handle attachments. You can access the fields transparently with doc[&quot;fieldname&quot;] since this struct implements the Elixir Access behaviour. You can also retrieve or pattern match the internal document with the fields attribute. Note that you should not manipulate the fields directly, especially the attachments. This is because of the efficient multipart transmission which requires the attachments to be in the same order within the JSON as in the multipart body. The accessor functions provided in this module handle this."},{"ref":"ICouch.Document.html#attachment_data_size/1","title":"ICouch.Document.attachment_data_size/1","type":"function","doc":"Returns the sum of all attachment data sizes in doc. The calculation is done for data that actually is present in this document, not neccessarily all attachments that are referenced in _attachments."},{"ref":"ICouch.Document.html#attachment_data_size/2","title":"ICouch.Document.attachment_data_size/2","type":"function","doc":"Returns the size of the attachment data specified by filename in doc. Note that this will return 0 if the attachment data is missing and/or the attachment does not exist."},{"ref":"ICouch.Document.html#delete/2","title":"ICouch.Document.delete/2","type":"function","doc":"Deletes the entry in doc for a specific key. If the key does not exist, returns doc unchanged."},{"ref":"ICouch.Document.html#delete_attachment/2","title":"ICouch.Document.delete_attachment/2","type":"function","doc":"Deletes the attachment specified by filename from doc. Returns the document unchanged, if the attachment didn&#39;t exist."},{"ref":"ICouch.Document.html#delete_attachment_data/1","title":"ICouch.Document.delete_attachment_data/1","type":"function","doc":"Deletes the attachment data of all attachments in doc. This does not delete the respective attachment info (stub)."},{"ref":"ICouch.Document.html#delete_attachment_data/2","title":"ICouch.Document.delete_attachment_data/2","type":"function","doc":"Deletes the attachment data specified by filename from doc."},{"ref":"ICouch.Document.html#delete_attachments/1","title":"ICouch.Document.delete_attachments/1","type":"function","doc":"Deletes all attachments and attachment data from doc."},{"ref":"ICouch.Document.html#deleted?/1","title":"ICouch.Document.deleted?/1","type":"function","doc":"Returns whether the document is marked as deleted."},{"ref":"ICouch.Document.html#equal?/2","title":"ICouch.Document.equal?/2","type":"function","doc":"Tests two documents for equality. Includes _id, _rev and _revisions/_revs_info. Attachments are compared using equal_attachments?/2."},{"ref":"ICouch.Document.html#equal_attachments?/2","title":"ICouch.Document.equal_attachments?/2","type":"function","doc":"Tests the attachments of two documents for equality. An attachment is considered equal if the name, content_type, length and digest are equal. If digests are absent, the data will be checked for equality; if both documents do not hold attachment data, this is considered equal as well."},{"ref":"ICouch.Document.html#equal_content?/2","title":"ICouch.Document.equal_content?/2","type":"function","doc":"Tests two documents for field equality. Ignores _id, _rev and _revisions. Attachments are compared using equal_attachments?/2."},{"ref":"ICouch.Document.html#fetch/2","title":"ICouch.Document.fetch/2","type":"function","doc":"Fetches the field value for a specific key in the given doc. If doc contains the given key with value value, then {:ok, value} is returned. If doc doesn&#39;t contain key, :error is returned. Part of the Access behavior."},{"ref":"ICouch.Document.html#from_api/1","title":"ICouch.Document.from_api/1","type":"function","doc":"Deserializes a document from a map or binary. If attachments with data exist, they will be decoded and stored in the struct separately."},{"ref":"ICouch.Document.html#from_api!/1","title":"ICouch.Document.from_api!/1","type":"function","doc":"Like from_api/1 but raises an error on decoding failures."},{"ref":"ICouch.Document.html#from_multipart/1","title":"ICouch.Document.from_multipart/1","type":"function","doc":"Deserializes a document including its attachment data from a list of multipart segments as returned by ICouch.Multipart.split/2."},{"ref":"ICouch.Document.html#full_json_byte_size/1","title":"ICouch.Document.full_json_byte_size/1","type":"function","doc":"Returns the approximate size of this document if it was encoded entirely in JSON, including the attachments being represented as as Base64."},{"ref":"ICouch.Document.html#get/3","title":"ICouch.Document.get/3","type":"function","doc":"Gets the field value for a specific key in doc. If key is present in doc with value value, then value is returned. Otherwise, default is returned (which is nil unless specified otherwise). Part of the Access behavior."},{"ref":"ICouch.Document.html#get_and_update/3","title":"ICouch.Document.get_and_update/3","type":"function","doc":"Gets the field value from key and updates it, all in one pass. fun is called with the current value under key in doc (or nil if key is not present in doc) and must return a two-element tuple: the &quot;get&quot; value (the retrieved value, which can be operated on before being returned) and the new value to be stored under key in the resulting new document. fun may also return :pop, which means the current value shall be removed from doc and returned (making this function behave like Document.pop(doc, key). The returned value is a tuple with the &quot;get&quot; value returned by fun and a new document with the updated value under key. Part of the Access behavior."},{"ref":"ICouch.Document.html#get_attachment/2","title":"ICouch.Document.get_attachment/2","type":"function","doc":"Returns both the info and data of the attachment specified by filename if present or nil. The data itself can be missing."},{"ref":"ICouch.Document.html#get_attachment_data/1","title":"ICouch.Document.get_attachment_data/1","type":"function","doc":"Returns a list of tuples with attachment names and data, in the order in which they will appear in the serialized JSON. Note that the list will also contain attachments that have no associated data."},{"ref":"ICouch.Document.html#get_attachment_data/2","title":"ICouch.Document.get_attachment_data/2","type":"function","doc":"Returns the data of the attachment specified by filename if present or nil."},{"ref":"ICouch.Document.html#get_attachment_info/2","title":"ICouch.Document.get_attachment_info/2","type":"function","doc":"Returns the attachment info (stub) for a specific filename or nil if not found."},{"ref":"ICouch.Document.html#has_attachment?/2","title":"ICouch.Document.has_attachment?/2","type":"function","doc":"Returns whether an attachment with the given filename exists."},{"ref":"ICouch.Document.html#has_attachment_data?/2","title":"ICouch.Document.has_attachment_data?/2","type":"function","doc":"Returns whether the attachment specified by filename is present and has data associated with it."},{"ref":"ICouch.Document.html#json_byte_size/1","title":"ICouch.Document.json_byte_size/1","type":"function","doc":"Returns the approximate size of this document if it was encoded in JSON. Does not include the attachment data."},{"ref":"ICouch.Document.html#new/2","title":"ICouch.Document.new/2","type":"function","doc":"Creates a new document struct. You can create an empty document or give it an ID and revision number or create a document struct from a map."},{"ref":"ICouch.Document.html#pop/3","title":"ICouch.Document.pop/3","type":"function","doc":"Returns and removes the field value associated with key in doc. If key is present in doc with value value, {value, new_doc} is returned where new_doc is the result of removing key from doc. If key is not present in doc, {default, doc} is returned."},{"ref":"ICouch.Document.html#put/3","title":"ICouch.Document.put/3","type":"function","doc":"Puts the given field value under key in doc. The _attachments field is treated specially: Any given data is decoded internally and the length attribute is set The follows attribute is removed and the stub attribute is set If the attachments are given as list of tuples, their order is preserved If the document already had attachments: If data is set for any given attachment, it will override existing data; if not, existing data is kept If the attachments are given as map, the existing order is preserved; if not, the order is taken from the list"},{"ref":"ICouch.Document.html#put_attachment/5","title":"ICouch.Document.put_attachment/5","type":"function","doc":""},{"ref":"ICouch.Document.html#put_attachment_data/3","title":"ICouch.Document.put_attachment_data/3","type":"function","doc":"Inserts or updates the attachment data in doc for the attachment specified by filename. The attachment info (stub) has to exist or an error is raised."},{"ref":"ICouch.Document.html#put_attachment_info/3","title":"ICouch.Document.put_attachment_info/3","type":"function","doc":"Inserts or updates the attachment info (stub) in doc for the attachment specified by filename."},{"ref":"ICouch.Document.html#revisions/1","title":"ICouch.Document.revisions/1","type":"function","doc":"Returns a list of full revision numbers given through the document&#39;s _revisions or _revs_info field, or nil if the both fields are missing or invalid. The revisions are sorted from newest to oldest."},{"ref":"ICouch.Document.html#set_deleted/2","title":"ICouch.Document.set_deleted/2","type":"function","doc":"Marks the document as deleted. This removes all fields except _id and _rev and deletes all attachments unless keep_fields is set to true."},{"ref":"ICouch.Document.html#set_id/2","title":"ICouch.Document.set_id/2","type":"function","doc":"Set the document ID for doc. Attempts to set it to nil will actually remove the ID from the document."},{"ref":"ICouch.Document.html#set_rev/2","title":"ICouch.Document.set_rev/2","type":"function","doc":"Set the revision number for doc. Attempts to set it to nil will actually remove the revision number from the document."},{"ref":"ICouch.Document.html#to_api/2","title":"ICouch.Document.to_api/2","type":"function","doc":"Serializes the given document to a binary. This will encode the attachments unless multipart: true is given as option at which point the attachments that have data are marked with &quot;follows&quot;: true. The attachment order is maintained."},{"ref":"ICouch.Document.html#to_api!/2","title":"ICouch.Document.to_api!/2","type":"function","doc":"Like to_api/1 but raises an error on encoding failures."},{"ref":"ICouch.Document.html#to_multipart/1","title":"ICouch.Document.to_multipart/1","type":"function","doc":"Serializes the given document including its attachment data to a list of multipart segments as consumed by ICouch.Multipart.join/2."},{"ref":"ICouch.Document.html#t:key/0","title":"ICouch.Document.key/0","type":"type","doc":""},{"ref":"ICouch.Document.html#t:t/0","title":"ICouch.Document.t/0","type":"type","doc":""},{"ref":"ICouch.Document.html#t:value/0","title":"ICouch.Document.value/0","type":"type","doc":""},{"ref":"ICouch.Multipart.html","title":"ICouch.Multipart","type":"module","doc":"Module for handling multipart streams. Used internally, but can be used in other applications."},{"ref":"ICouch.Multipart.html#get_boundary/1","title":"ICouch.Multipart.get_boundary/1","type":"function","doc":"Reads the subtype and boundary from a multipart/* content type header, if found."},{"ref":"ICouch.Multipart.html#join/2","title":"ICouch.Multipart.join/2","type":"function","doc":"Joins all given parts into one multipart stream."},{"ref":"ICouch.Multipart.html#join_part/3","title":"ICouch.Multipart.join_part/3","type":"function","doc":"Joins a part to form a chunk of multipart stream data. According to specification, each part ends with a line break after the data."},{"ref":"ICouch.Multipart.html#split/2","title":"ICouch.Multipart.split/2","type":"function","doc":"Splits an entire multipart stream into its parts. Returns error if the stream is incomplete."},{"ref":"ICouch.Multipart.html#split_part/2","title":"ICouch.Multipart.split_part/2","type":"function","doc":"Splits the incoming data up if a boundary was found. Also expects and extracts the header. Return values: previous - data which belongs to the previous part, ready to be used; can be empty next_headers - if not nil, a new part has been found; can be an empty map rest - data which might belong to the next part or is uncertain; nil when an end boundary has been found"},{"ref":"ICouch.Replicator.html","title":"ICouch.Replicator","type":"module","doc":"Optimized &quot;software&quot; replicator for CouchDB. Implements a GenServer for replicating databases. It chooses the best strategy per document, resulting as little calls and throughput as possible while not overcrowding batch requests. The status can be queried while the replicator is running."},{"ref":"ICouch.Replicator.html#child_spec/1","title":"ICouch.Replicator.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ICouch.Replicator.html#init/1","title":"ICouch.Replicator.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ICouch.Replicator.html#start_link/4","title":"ICouch.Replicator.start_link/4","type":"function","doc":""},{"ref":"ICouch.Replicator.html#status/1","title":"ICouch.Replicator.status/1","type":"function","doc":""},{"ref":"ICouch.RequestError.html","title":"ICouch.RequestError","type":"exception","doc":"Wraps REST and connection errors from CouchDB."},{"ref":"ICouch.RequestError.html#message_for_reason/1","title":"ICouch.RequestError.message_for_reason/1","type":"function","doc":"Translates a well-known error to an message to be used in the exception."},{"ref":"ICouch.RequestError.html#parse_status_code/1","title":"ICouch.RequestError.parse_status_code/1","type":"function","doc":"Parses a status code from ibrowse to a well-known error."},{"ref":"ICouch.RequestError.html#req_result_or_raise!/1","title":"ICouch.RequestError.req_result_or_raise!/1","type":"macro","doc":""},{"ref":"ICouch.RequestError.html#t:well_known_error/0","title":"ICouch.RequestError.well_known_error/0","type":"type","doc":""},{"ref":"ICouch.Server.html","title":"ICouch.Server","type":"module","doc":"Holds information about CouchDB server connections and encapsulates API calls."},{"ref":"ICouch.Server.html#credentials/1","title":"ICouch.Server.credentials/1","type":"function","doc":"Returns a tuple of username and password which has been set in the server struct (or nil if not given)."},{"ref":"ICouch.Server.html#delete_credentials/1","title":"ICouch.Server.delete_credentials/1","type":"function","doc":"Returns a server struct without credentials."},{"ref":"ICouch.Server.html#endpoint_with_options/2","title":"ICouch.Server.endpoint_with_options/2","type":"function","doc":"Encodes CouchDB style query options together with an endpoint and returns the resulting relative URI. This function is applied to the entrypoint parameter of send_raw_req/6 and indirectly to send_req/4. To be specific, the following option values are converted to a plain string: rev, filter, view, since, startkey_docid, endkey_docid These options are deleted: multipart, stream_to The batch option is either converted to :ok on true, or removed on false. Options with values that are atoms are also converted to a plain string. Options with nil values are removed. Options given through query_params are also kept as-is but cannot override an option given normally. Any other option value is converted to its JSON representation."},{"ref":"ICouch.Server.html#has_gzip_encoding?/1","title":"ICouch.Server.has_gzip_encoding?/1","type":"function","doc":"Helper function to determine if an enumerable header contains Content-Encoding (case insensitive) that is set to gzip (case sensitive)."},{"ref":"ICouch.Server.html#new/2","title":"ICouch.Server.new/2","type":"function","doc":"See ICouch.server_connection/2."},{"ref":"ICouch.Server.html#pop_credentials/1","title":"ICouch.Server.pop_credentials/1","type":"function","doc":"Returns and removes the credentials in the given server struct. If credentials are present, {{username, password}, new_server} is returned where new_server is the result of removing the credentials from server. If no credentials are present, {nil, server} is returned."},{"ref":"ICouch.Server.html#send_raw_req/6","title":"ICouch.Server.send_raw_req/6","type":"function","doc":"Invokes an arbitrary CouchDB API call which may or may not be implementation specific. This expects the request body to be sent as binary (or function yielding binary chunks) and returns the raw response headers and the body as binary. There are no checks made if the request method actually allows a request body. To use transparent JSON encoding and decoding for the requests use send_req/4."},{"ref":"ICouch.Server.html#send_req/4","title":"ICouch.Server.send_req/4","type":"function","doc":"Invokes an arbitrary CouchDB API call which may or may not be implementation specific. Many functions of the main module make use of this function. It is exposed publicly so you can call arbitrary API functions yourself. Note that there is transparent JSON encoding and decoding for the requests and the response headers are discarded; if you need raw data or the headers, use send_raw_req/6. Also checks are made if the request method actually allows a request body and discards it if needed."},{"ref":"ICouch.Server.html#t:body/0","title":"ICouch.Server.body/0","type":"type","doc":""},{"ref":"ICouch.Server.html#t:endpoint/0","title":"ICouch.Server.endpoint/0","type":"type","doc":"An endpoint can be given as plain path, as 2-tuple of a path and (query) options or as URI.t. The path cannot contain a query string; if you need to specify a custom query string, convert the path including the query string with URI.parse/1."},{"ref":"ICouch.Server.html#t:method/0","title":"ICouch.Server.method/0","type":"type","doc":""},{"ref":"ICouch.Server.html#t:option/0","title":"ICouch.Server.option/0","type":"type","doc":""},{"ref":"ICouch.Server.html#t:t/0","title":"ICouch.Server.t/0","type":"type","doc":""},{"ref":"ICouch.StreamChunk.html","title":"ICouch.StreamChunk","type":"module","doc":"Struct module for stream chunks. The name field will hold the document ID on document streaming, both document ID and attachment name on attachment streaming and nil on changes streaming."},{"ref":"ICouch.StreamChunk.html#for_attachment/4","title":"ICouch.StreamChunk.for_attachment/4","type":"function","doc":""},{"ref":"ICouch.StreamChunk.html#for_document/3","title":"ICouch.StreamChunk.for_document/3","type":"function","doc":""},{"ref":"ICouch.StreamChunk.html#t:t/0","title":"ICouch.StreamChunk.t/0","type":"type","doc":""},{"ref":"ICouch.StreamEnd.html","title":"ICouch.StreamEnd","type":"module","doc":"Struct module for stream ends. The document stream ends when all attachments have been streamed."},{"ref":"ICouch.StreamEnd.html#for_attachment/3","title":"ICouch.StreamEnd.for_attachment/3","type":"function","doc":""},{"ref":"ICouch.StreamEnd.html#for_document/2","title":"ICouch.StreamEnd.for_document/2","type":"function","doc":""},{"ref":"ICouch.StreamEnd.html#t:t/0","title":"ICouch.StreamEnd.t/0","type":"type","doc":""},{"ref":"ICouch.View.html","title":"ICouch.View","type":"module","doc":"Module to handle views in CouchDB. View structs should not be created or manipulated directly, please use ICouch.open_view/3 or ICouch.open_view!/3. The view struct implements the enumerable protocol for easy handling with Elixir&#39;s Enum module. A view can be in a &quot;fetched&quot; state or in an &quot;unfetched&quot; state which can be tested with the fetched?/1 function and changed with the fetch/1, fetch!/1 and unfetch/1 function. Note that iterating over an unfetched view will create an intermediate fetched version."},{"ref":"ICouch.View.html#db_endpoint/1","title":"ICouch.View.db_endpoint/1","type":"function","doc":"Internal function to build a db endpoint."},{"ref":"ICouch.View.html#delete_option/2","title":"ICouch.View.delete_option/2","type":"function","doc":"Deletes an option in view. This will also set the view back to the &quot;unfetched&quot; state. Returns view unchanged if the option was not set (and it already was &quot;unfetched&quot;)."},{"ref":"ICouch.View.html#fetch/1","title":"ICouch.View.fetch/1","type":"function","doc":"Fetches all rows of view, turning it into a &quot;fetched view&quot;."},{"ref":"ICouch.View.html#fetch!/1","title":"ICouch.View.fetch!/1","type":"function","doc":"Same as fetch/1 but returns the fetched view directly on success or raises an error on failure."},{"ref":"ICouch.View.html#fetched?/1","title":"ICouch.View.fetched?/1","type":"function","doc":"Tests whether view is in &quot;fetched&quot; state or not."},{"ref":"ICouch.View.html#get_option/2","title":"ICouch.View.get_option/2","type":"function","doc":"Returns the value of an option in view or nil if it was not set."},{"ref":"ICouch.View.html#put_option/3","title":"ICouch.View.put_option/3","type":"function","doc":"Adds or updates a single option in view. This will also set the view back to the &quot;unfetched&quot; state."},{"ref":"ICouch.View.html#set_options/2","title":"ICouch.View.set_options/2","type":"function","doc":"Replaces view&#39;s options with the given ones. This will also set the view back to the &quot;unfetched&quot; state."},{"ref":"ICouch.View.html#unfetch/1","title":"ICouch.View.unfetch/1","type":"function","doc":"Resets view back to the &quot;unfetched&quot; state."},{"ref":"ICouch.View.html#t:t/0","title":"ICouch.View.t/0","type":"type","doc":""},{"ref":"ICouch.View.html#t:view_option_key/0","title":"ICouch.View.view_option_key/0","type":"type","doc":""},{"ref":"ICouch.View.html#t:view_option_value/0","title":"ICouch.View.view_option_value/0","type":"type","doc":""},{"ref":"Mix.Tasks.Icouch.Backup.html","title":"Mix.Tasks.Icouch.Backup","type":"task","doc":""},{"ref":"Mix.Tasks.Icouch.Backup.html#run/1","title":"Mix.Tasks.Icouch.Backup.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Icouch.Backup.html#save_bulk_docs/3","title":"Mix.Tasks.Icouch.Backup.save_bulk_docs/3","type":"function","doc":""},{"ref":"Mix.Tasks.Icouch.Replicate.html","title":"Mix.Tasks.Icouch.Replicate","type":"task","doc":""},{"ref":"Mix.Tasks.Icouch.Replicate.html#run/1","title":"Mix.Tasks.Icouch.Replicate.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Icouch.Restore.html","title":"Mix.Tasks.Icouch.Restore","type":"task","doc":""},{"ref":"Mix.Tasks.Icouch.Restore.html#run/1","title":"Mix.Tasks.Icouch.Restore.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Icouch.Utils.html","title":"Mix.Tasks.Icouch.Utils","type":"task","doc":""},{"ref":"Mix.Tasks.Icouch.Utils.html#human_bytesize/1","title":"Mix.Tasks.Icouch.Utils.human_bytesize/1","type":"function","doc":""},{"ref":"Mix.Tasks.Icouch.Utils.html#human_bytesize/2","title":"Mix.Tasks.Icouch.Utils.human_bytesize/2","type":"function","doc":""},{"ref":"Mix.Tasks.Icouch.Utils.html#join_invalid_args/2","title":"Mix.Tasks.Icouch.Utils.join_invalid_args/2","type":"function","doc":""},{"ref":"Mix.Tasks.Icouch.Utils.html#progress_string/2","title":"Mix.Tasks.Icouch.Utils.progress_string/2","type":"function","doc":""},{"ref":"Mix.Tasks.Icouch.Utils.html#take_db_name/1","title":"Mix.Tasks.Icouch.Utils.take_db_name/1","type":"function","doc":""},{"ref":"readme.html","title":"ICouch","type":"extras","doc":"ICouch"},{"ref":"readme.html#description","title":"ICouch - Description","type":"extras","doc":"ICouch is a CouchDB client for Elixir using ibrowse for HTTP transfer. JSON encoding/decoding is provided by Poison. ICouch claims to be more &quot;Elixir Style&quot; than other implementations based on couchbeam and offers a more rigid changes follower tested against vanilla CouchDB and Cloudant. That said, many calls might look and behave similarly like couchbeam&#39;s since the intent is often the same. However, parameter order and types will differ in most cases; most notably maps are used instead of JSON keyword lists. Another innovation is, that documents are represented as Elixir structs. These offer a way to conveniently manage attachments in binary form and also implement the Access behavior and Enumerable protocol for easy handling of a document&#39;s fields."},{"ref":"readme.html#status","title":"ICouch - Status","type":"extras","doc":"This project is currently in beta phase. ToDo&#39;s: Implement view streaming Implement one-shot changes streaming Finish documentation Write more tests"},{"ref":"readme.html#installation","title":"ICouch - Installation","type":"extras","doc":"Add ICouch to your list of dependencies in mix.exs: def deps do [{:icouch, &quot;~&gt; 0.5&quot;}] end"},{"ref":"readme.html#usage","title":"ICouch - Usage","type":"extras","doc":"(todo)"},{"ref":"readme.html#author","title":"ICouch - Author","type":"extras","doc":"Patrick Schneider / MeetNow! GmbH"},{"ref":"readme.html#license","title":"ICouch - License","type":"extras","doc":"Copyright (c) 2017,2018 MeetNow! GmbH ICouch source code is released under Apache 2 License. Check the LICENSE file for more information."}]